Index: roarclients/roarctl.c
===================================================================
--- roarclients/roarctl.c	(revision 6052)
+++ roarclients/roarctl.c	(revision 0)
@@ -1,396 +1,38 @@
 //roarctl.c:
 
-/*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2015
- *
- *  This file is part of roarclients a part of RoarAudio,
- *  a cross-platform sound system for both, home and professional use.
- *  See README for details.
- *
- *  This file is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License version 3
- *  as published by the Free Software Foundation.
- *
- *  RoarAudio is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
- *  Boston, MA 02110-1301, USA.
- *
- */
-
-/* ckport options:
- * ckport: ignore-symbol: roar_req of target libroar0 -- Used within ping command.
- */
-
-#define _UNITS_T_BASE_USEC
-
 #include <roaraudio.h>
-#include <roaraudio/units.h>
-#include <libroardsp/libroardsp.h>
-
-#if defined(ROAR_HAVE_SETGID) && defined(ROAR_HAVE_SETUID)
-#define _POSIX_USERS
-#endif
-
-#ifdef _POSIX_USERS
-#include <pwd.h>
-#include <grp.h>
-#endif
-
-#include <sys/time.h>
-#include <time.h>
-
-#ifdef ROAR_HAVE_LIBM
-#include <math.h>
-#endif
-
-int g_verbose = 0;
-
-void display_client (struct roar_connection * con, int id);
-void display_stream (struct roar_connection * con, int id);
-int display_mixer (struct roar_connection * con, int stream);
-int show_meta_all (struct roar_connection * con, int id);
 
 void usage (void) {
- printf("roarctl [OPTIONS]... COMMAND [OPTS] [COMMAND [OPTS] [COMMAND [OPTS] [...]]]\n");
+ printf("roarcat [OPTIONS]... COMMAND [OPTS] [COMMAND [OPTS] [COMMAND [OPTS] [...]]]\n");
 
  printf("\nOptions:\n\n");
 
- printf("  --server SERVER         - Set server hostname\n"
-        "  --help                  - Show this help\n"
-        "  --verbose   -v          - Show verbose output\n"
-        "  --list-aiprofiles       - Show audio info profiles and exit\n"
-        "  --list-libstandards     - Gets list of library (libroar) supported standards\n"
-        "  --enum-servers          - Show a list of possible servers\n"
-        "  --hash-password         - Hash a password and exit\n"
+ printf("  --server SERVER    - Set server hostname\n"
+        "  --help             - Show this help\n"
        );
 
  printf("\nCommands:\n\n");
  printf(
-        "  help                    - Show this help\n"
-        "  sleep TIME              - Sleeps for TIME seconds\n"
-#ifdef ROAR_HAVE_GETTIMEOFDAY
-        "  ping  NUM               - Do NUM pings using NOOP commands\n"
-#endif
-        "  servername              - Show name of server currently connected to\n"
-        "  whoami                  - Get own client ID\n"
+        "  help               - Show this help\n"
         "\n"
-        "  beep                    - Ask the server to beep.\n"
+        "  standby, off       - Go into standby mode\n"
+        "  resume, on         - Go into active mode\n"
+        "  standbymode        - Show current standby mode\n"
+        "  exit               - Quits the roard (must be used as last command)\n"
         "\n"
-        "  listaiprofiles          - list audio info profiles\n"
-        "  aiprofileget PROFILE    - show audio info profile PROFILE\n"
+        "  kick TYPE ID       - Kicks object of TYPE with id ID\n"
+        "                       Types: client stream sample source\n"
         "\n"
-        "  standby, off            - Go into standby mode\n"
-        "  resume, on              - Go into active mode\n"
-        "  standbymode             - Show current standby mode\n"
-        "  exit                    - Quits the roard (must be used as last command)\n"
-        "  terminate               - Like exit but let the server up to serve still connected clients,\n"
-        "                            new clients cann't connect and the server terminates after the last\n"
-        "                            client disconnected\n"
-        "\n"
-        "  volume ID CHAN [scale S] V0 V1...\n"
-        "                          - Sets volume for stream ID\n"
-        "                            CHAN is the number of channels or 'mono' or 'stereo'\n"
-        "                            if mono or stereo is chosen roarctl trys to set\n"
-        "                            sensfull values for all channels even if the output\n"
-        "                            is has more channels.\n"
-        "                            An optional scale can be given using S.\n"
-        "                            all other args are the volumes of the channels\n"
-        "                            you may use integer or percent values.\n"
-        "                            percent values can floating points.\n"
-        "\n"
-        "  flag   ID FLAGS         - Sets flags FLAGS on stream ID. FLAGS may be a comma\n"
-        "                            separated list of flags.\n"
-        "  unflag ID FLAGS         - Unsets flags on a stream. See flag.\n"
-        "  toogleflag ID FLAGS     - Toggels flags on a stream. See flag.\n"
-        "  protectflag ID FLAGS    - Protects flags on a stream. Those flags can not be\n"
-        "                            changed anymore after the they got protected. See flag.\n"
-        "\n"
-        "  role ID ROLE            - Set role ROLE on stream ID.\n"
-        "\n"
-        "  kick TYPE ID            - Kicks object of TYPE with id ID\n"
-        "                            Types: client stream sample source\n"
-        "  newvirtual P D E R B C  - Adds a new virtual (child) stream\n"
-        "                            Parameters:\n"
-        "                             P: Parent stream ID, D: Direction,\n"
-        "                             E: codEc, R: sample Rate,\n"
-        "                             B: bits per sample, C: nummer of channels\n"
-        "\n"
-        "  metaget  ID TYPE        - Read meta date of type TYPE from stream ID\n"
-// TODO: document metaset here.
-        "  metasave ID FILE        - Saves meta data of stream ID to file FILE\n"
-        "  metaload ID FILE        - Loads meta data from file FILE and set it on stream ID\n"
-        "\n"
-        "  serverinfo              - Gets general information about the server\n"
-        "  libinfo                 - Gets general information about the library (libroar)\n"
-        "  servertime              - Gets server's time\n"
-        "  serveroinfo             - Gets Information about server output\n"
-        "  serveroinfo2 DIR        - Gets Information about server output for stream direction dir\n"
-        "\n"
-        "  serverstandards         - Gets list of server supported standards\n"
-        "  libstandards            - Gets list of library (libroar) supported standards\n"
-        "\n"
-        "  listclients             - Gets Information about clients\n"
-        "  clientinfo ID           - Gets Information about client ID\n"
-        "  liststreams             - Gets Information about streams\n"
-        "  streaminfo ID           - Gets Information about stream ID\n"
-        "  allinfo                 - Get all infos\n"
+        "  serveroinfo        - Gets Informations about server output\n"
+        "  listclients        - Gets Informations about clients\n"
+        "  liststreams        - Gets Informations about streams\n"
+        "  allinfo            - Get all infos\n"
        );
 }
 
-static void _bin2hex(char * out, char * in, size_t inlen, int uppercase) {
- const char * tab = uppercase ? "0123456789ABCDEF" : "0123456789abcdef";
- unsigned char c;
- int nib0, nib1;
-
- for (; inlen; inlen--) {
-  c = *(in++);
-  nib0 = (c & 0x0F) >> 0;
-  nib1 = (c & 0xF0) >> 4;
-//  printf("inlen=%zu, c=%u, nibs={%i, %i}\n", inlen, (unsigned)c, nib1, nib0);
-  *(out++) = tab[nib1];
-  *(out++) = tab[nib0];
- }
- *out = 0;
-}
-
-int hash_password (void) {
- char * pw = NULL;
- char salt[8];
- char digest[24];
- char out[2*(8+24)+3+5+1] = "tiger:";
-
- if ( roar_passwd_simple_ask_pw(&pw, "Password to hash?", NULL) == -1 )
-  return -1;
-
- roar_random_gen_nonce(salt, sizeof(salt));
-
- roar_hash_salted_buffer(digest, pw, roar_mm_strlen(pw), ROAR_HT_TIGER, salt, sizeof(salt));
-
- roar_mm_free(pw);
-
- _bin2hex(out+6, salt, sizeof(salt), 0);
- out[6+16] = ':';
- _bin2hex(out+6+16+1, digest, sizeof(digest), 0);
-
- out[sizeof(out)-1] = 0;
-
- printf("Password: %s\n", out);
-
- return 0;
-}
-
-int enum_servers (void) {
- struct roar_server * list;
- struct roar_server * c;
- int flags    = ROAR_ENUM_FLAG_DESC|ROAR_ENUM_FLAG_LOCATION;
- int dir      = -1;
- int socktype = -1;
- int i;
-
- if ( (list = roar_enum_servers(flags, dir, socktype)) == NULL )
-  return -1;
-
- printf("Server           Location         Description\n");
- printf("----------------------------------------------------------------------\n");
-
- for (i = 0; ; i++) {
-  c = &(list[i]);
-  printf("%-16s %-16s %s\n",
-             c->server      == NULL ? "(default)" : c->server,
-             c->location    == NULL ? ""          : c->location,
-             c->description == NULL ? ""          : c->description
-        );
-  if ( c->server == NULL )
-   break;
- }
-
- roar_enum_servers_free(list);
-
- return 0;
-}
-
-#ifdef ROAR_HAVE_GETTIMEOFDAY
-int ping (struct roar_connection * con, int num) {
- struct timeval         try, ans;
- struct roar_message    m;
- register int           ret;
- int                    i;
- double                 cur, min = 3600*1000, max = 0, sum = 0;
-
- if ( num == 0 )
-  return 0;
-
- for (i = 0; i < num; i++) {
-  memset(&m, 0, sizeof(m));
-
-  m.cmd = ROAR_CMD_NOOP;
-  m.stream  = -1;
-  m.datalen =  0;
-
-  // we use roar_req() directly here because of speed.
-  // roar_noop() does basicly the same but is a bit slower.
-
-  gettimeofday(&try, NULL);
-  ret = roar_req(con, &m, NULL);
-  gettimeofday(&ans, NULL);
-
-  if ( ret == -1 )
-   return -1;
-
-  while (ans.tv_sec > try.tv_sec) {
-   ans.tv_sec--;
-   ans.tv_usec += 1000000;
-  }
-  ans.tv_usec -= try.tv_usec;
-
-  cur = ans.tv_usec/1000.0;
-
-  printf("Pong from server: seq=%i time=%.3f%cs\n", i, cur < 0.5 ? cur*1000.0 : cur, cur < 0.5 ? 'u' : 'm');
-
-  sum += cur;
-  if ( min > cur )
-   min = cur;
-  if ( cur > max )
-   max = cur;
-
-  if ( i != (num - 1) )
-   roar_sleep(1);
- }
-
- printf("\n--- ping statistics ---\n");
- printf("%i packets transmitted\n", i);
- printf("rtt min/avg/max = %.3f/%.3f/%.3f ms\n", min, sum/(double)i, max);
-
- return 0;
-}
-#endif
-
-#define _pm(m,n) if ( info->m != NULL ) printf(con != NULL ? "Server %-15s: %s\n" : "Library %-14s: %s\n", (n), (info->m));
-void server_info (struct roar_connection * con) {
- struct roar_server_info * info = con != NULL ? roar_server_info(con) : roar_library_info();
- long hostid;
-
- if ( info == NULL ) {
-  fprintf(stderr, "Error: can not get server info\n");
-  return;
- }
-
- _pm(version, "Version");
- _pm(location, "Location");
- _pm(description, "Description");
- _pm(contact, "Contact");
- _pm(serial, "Serial");
- _pm(address, "Address");
- _pm(uiurl, "UI URL");
- _pm(license, "License");
-// _pm(hostid, "HostID");
- if ( info->hostid != NULL ) {
-  if ( sscanf(info->hostid, "0x%lx", &hostid) != 1 )
-   hostid = 0;
-
-  if ( hostid ) {
-   printf(con != NULL ? "Server %-15s: %s (%li.%li.%li.%li)\n"
-                      : "Library %-14s: %s (%li.%li.%li.%li)\n", "HostID", info->hostid,
-           ((hostid & 0x00FF0000UL) >> 16UL),
-           ((hostid & 0xFF000000UL) >> 24UL),
-           ((hostid & 0x000000FFUL) >>  0UL),
-           ((hostid & 0x0000FF00UL) >>  8UL)
-         );
-  } else {
-   _pm(hostid, "HostID");
-  }
- }
- _pm(build, "Build");
- _pm(un.sysname, "System sysname");
- _pm(un.release, "System release");
- _pm(un.nodename, "System nodename");
- _pm(un.machine, "System machine");
-
- roar_server_info_free(info);
-}
-#undef _pm
-
-void server_time (struct roar_connection * con) {
- struct roar_time time;
-#ifdef ROAR_HAVE_CTIME_R
- time_t server_time;
- char server_time_buf[32];
-#endif
-
-
- if ( roar_get_time(con, &time) == -1 ) {
-  fprintf(stderr, "Error: can not get server time: %s\n", roar_vs_strerr(roar_error));
-  return;
- }
-
-#ifdef ROAR_HAVE_CTIME_R
- server_time = time.t_sec;
- if ( ctime_r(&server_time, server_time_buf) == NULL )
-  server_time_buf[0] = 0;
-
- if ( server_time_buf[0] )
-  if ( server_time_buf[strlen(server_time_buf)-1] == '\n' )
-   server_time_buf[strlen(server_time_buf)-1] = 0;
-#endif
-
- if ( g_verbose ) {
-  printf("Server time           : %s%s%s%" LIBROAR__ll "u.%06" LIBROAR__ll "u [+%" LIBROAR__ll "u/2^64] sec\n",
-#ifdef ROAR_HAVE_CTIME_R
-         "\"",
-         server_time_buf,
-         "\" ",
-#else
-         "", "", "",
-#endif
-         (LIBROAR__longlong unsigned int)time.t_sec,
-         (LIBROAR__longlong unsigned int) time.t_ssec / (LIBROAR__longlong unsigned int)18446744073709LLU,
-         (LIBROAR__longlong unsigned int) time.t_ssec);
- } else {
-  if ( time.c_freq == 1000000000LL && time.t_ssec == 0 ) {
-   printf("Server time           : %s%s%s%" LIBROAR__ll "u sec\n",
-#ifdef ROAR_HAVE_CTIME_R
-         "\"",
-         server_time_buf,
-         "\" ",
-#else
-         "", "", "",
-#endif
-          (LIBROAR__longlong unsigned int)time.t_sec);
-  } else {
-   printf("Server time           : %s%s%s%" LIBROAR__ll "u.%06" LIBROAR__ll"u sec\n",
-#ifdef ROAR_HAVE_CTIME_R
-         "\"",
-         server_time_buf,
-         "\" ",
-#else
-         "", "", "",
-#endif
-          (LIBROAR__longlong unsigned int)time.t_sec,
-          (LIBROAR__longlong unsigned int) time.t_ssec / (LIBROAR__longlong unsigned int)18446744073709LLU);
-  }
- }
- if ( time.c_freq )
-  printf("Server clock frequency: %f Hz\n", (float)((double)time.c_freq / (double)1000000000.));
- if ( time.c_drift ) {
-#ifdef ROAR_HAVE_LIBM
-  printf("Server clock drift    : %" LIBROAR__ll "u:2^64 (~10^%f)\n",
-         (LIBROAR__longlong unsigned int)time.c_drift, logf((float)time.c_drift)/2.302585f);
-#else
-  printf("Server clock drift    : %" LIBROAR__ll "u:2^64\n",
-         (LIBROAR__longlong unsigned int)time.c_drift);
-#endif
- }
-}
-
-void server_oinfo (struct roar_connection * con, int dir) {
+void server_oinfo (struct roar_connection * con) {
  struct roar_stream s;
 
- if ( roar_server_oinfo(con, &s, dir) == -1 ) {
+ if ( roar_server_oinfo(con, &s) == -1 ) {
   fprintf(stderr, "Error: can not get server output info\n");
   return;
@@ -398,5 +40,5 @@
 
  printf("Stream direction      : %s\n", roar_dir2str(s.dir));
- printf("Server Output rate    : %i Hz\n", s.info.rate);
+ printf("Server Output rate    : %i\n", s.info.rate);
  printf("Server Output bits    : %i\n", s.info.bits);
  printf("Server Output channels: %i\n", s.info.channels);
@@ -404,85 +46,4 @@
                                      s.info.codec == ROAR_CODEC_DEFAULT ? " native" : "");
 // printf("Server Output rate: %i", s.info.rate);
-  if ( g_verbose > 1 && s.pos != (uint32_t)-1 ) {
-   if ( s.info.rate && s.info.channels ) {
-    printf("Server Position       : %lu S (%.3fs)\n", (unsigned long int) s.pos, (float)s.pos/(s.info.rate*s.info.channels));
-   } else {
-    printf("Server Position       : %lu S\n", (unsigned long int) s.pos);
-   }
-  }
-}
-
-static void print_stds (const struct roar_stds * stds) {
- size_t i;
- int vendor, standard, version;
- char numbuf[2][8];
- const char * vendor_name;
-
- for (i = 0; i < stds->stds_len; i++) {
-  vendor   = ROAR_STD_VENDOR(stds->stds[i]);
-  standard = ROAR_STD_STD(stds->stds[i]);
-  version  = ROAR_STD_VERSION(stds->stds[i]);
-
-  if ( (vendor_name = roar_stds_vendor2str(vendor)) == NULL ) {
-   snprintf(numbuf[0], sizeof(numbuf[0]), "%i", vendor);
-   numbuf[0][sizeof(numbuf[0])-1] = 0;
-   vendor_name = numbuf[0];
-  }
-
-  if ( version == 0 ) {
-   numbuf[1][0] = 0;
-  } else {
-   snprintf(numbuf[1], sizeof(numbuf[1]), "-%i", version);
-   numbuf[1][sizeof(numbuf[1])-1] = 0;
-  }
-
-  printf("Server standard       : %s-%i%s\n", vendor_name, standard, numbuf[1]);
- }
-}
-
-void server_standards (struct roar_connection * con) {
- struct roar_stds * stds;
-
- if ( roar_caps_stds(con, &stds, NULL, -1) == -1 ) {
-  fprintf(stderr, "Error: can not get server standards\n");
-  return;
- }
-
- print_stds(stds);
-
- roar_stds_free(stds);
-}
-
-void lib_standards (void) {
- print_stds(libroar_libstds());
-}
-
-const char * proc_name (pid_t pid) {
- static char ret[80] = "?";
-#ifdef __linux__
- char file[80], buf[80], *r;
- int  i;
-
- snprintf(file, sizeof(file)-1, "/proc/%i/exe", pid);
- file[sizeof(file)-1] = 0;
-
- ret[0] = '?';
- ret[1] = 0;
-
- if ( (i = readlink(file, buf, sizeof(buf)-1)) != -1 ) {
-  buf[i] = 0;
-  if ( (r = strrchr(buf, '/')) != NULL ) {
-   r++;
-   if ( *r != 0 ) {
-    strncpy(ret, r, sizeof(ret)-1);
-    ret[sizeof(ret)-1] = 0;
-   }
-  }
- }
-#else
- (void)pid;
-#endif
-
- return ret;
 }
 
@@ -490,5 +51,7 @@
  int i;
  int num;
+ int h;
  int id[ROAR_CLIENTS_MAX];
+ struct roar_client c;
 
  if ( (num = roar_list_clients(con, id, ROAR_CLIENTS_MAX)) == -1 ) {
@@ -498,96 +61,18 @@
 
  for (i = 0; i < num; i++) {
-  display_client(con, id[i]);
- }
-}
-
-void display_client (struct roar_connection * con, int id) {
- static int self_id = -1;
- static struct roar_client   self_client_store;
- static struct roar_client * self_client = NULL;
- struct roar_client c;
- char tmp[80];
- int h;
-#ifdef _POSIX_USERS
- struct group  * grp = NULL;
- struct passwd * pwd = NULL;
-#endif
-
- if ( self_id == -1 ) {
-  if ( (self_id = roar_get_clientid(con)) != -1 ) {
-   if ( roar_get_client(con, &self_client_store, self_id) == -1 ) {
-    self_id = -1;
-   } else {
-    self_client = &self_client_store;
-   }
-  }
- }
-
- printf("client %i:\n", id);
- if ( roar_get_client(con, &c, id) == -1 ) {
-  fprintf(stderr, "Error: can not get client info\n");
-  return;
- }
-
- if ( c.name[0] != '\0' )
-  printf("Client name           : %s\n", c.name);
-  if ( roar_nnode_get_socktype(&(c.nnode)) != ROAR_SOCKET_TYPE_UNKNOWN ) {
-  if ( roar_nnode_to_str(&(c.nnode), tmp, sizeof(tmp)) == 0 ) {
-   printf("Client network node   : %s\n", tmp);
-  }
- }
-
- if ( c.pid != -1 ) {
-  if ( self_id != -1 && roar_nnode_cmp(&(self_client->nnode), &(c.nnode)) == 0 ) {
-   printf("Client PID            : %i(%s)\n", c.pid, proc_name(c.pid));
-  } else { 
-   printf("Client PID            : %i\n", c.pid);
-  }
- }
- if ( c.uid != -1 ) {
-#ifdef _POSIX_USERS
-  if ( self_id != -1 && roar_nnode_cmp(&(self_client->nnode), &(c.nnode)) == 0 ) {
-   pwd = getpwuid(c.uid);
-   grp = getgrgid(c.gid);
-   printf("Client UID/GID        : %i(%s)/%i(%s)\n", c.uid, pwd ? pwd->pw_name : "?", c.gid, grp ? grp->gr_name : "?");
-  } else {
-#else
-  if ( 1 ) {
-#endif
-   printf("Client UID/GID        : %i/%i\n", c.uid, c.gid);
-  }
- }
-
- if ( g_verbose && c.proto != ROAR_PROTO_NONE ) {
-  printf("Client Protocol       : %s\n", roar_proto2str(c.proto));
- }
-
- if ( g_verbose && c.byteorder != ROAR_BYTEORDER_UNKNOWN ) {
-  if ( c.byteorder == ROAR_BYTEORDER_NETWORK ) {
-   roar_mm_strscpy(tmp, " (network byteorder");
-  } else {
-   *tmp = 0;
-  }
-
-  if ( c.byteorder == ROAR_BYTEORDER_NATIVE ) {
-   if ( *tmp ) {
-    roar_mm_strscat(tmp, ", native");
-   } else {
-    roar_mm_strscpy(tmp, " (native");
-   }
-  }
-
-  if ( *tmp )
-   roar_mm_strscat(tmp, ")");
-
-  printf("Client Byteorder      : %s%s\n", roar_byteorder2str(c.byteorder), tmp);
- }
-
- if ( c.execed != -1 )
-  printf("Execed stream         : %i\n", c.execed);
-
- for (h = 0; h < ROAR_CLIENTS_MAX_STREAMS_PER_CLIENT; h++)
-  if ( c.streams[h] != -1 )
-   printf("stream                : %i\n", c.streams[h]);
+  printf("client %i:\n", id[i]);
+  if ( roar_get_client(con, &c, id[i]) == -1 ) {
+   fprintf(stderr, "Error: can not get client info\n");
+   continue;
+  }
+  printf("Player name           : %s\n", c.name);
+  if ( c.execed != -1 )
+   printf("Execed stream         : %i\n", c.execed);
+
+  for (h = 0; h < ROAR_CLIENTS_MAX_STREAMS_PER_CLIENT; h++)
+   if ( c.streams[h] != -1 )
+    printf("stream                : %i\n", c.streams[h]);
+ }
+
 }
 
@@ -596,4 +81,6 @@
  int num;
  int id[ROAR_STREAMS_MAX];
+ struct roar_stream s;
+
 
  if ( (num = roar_list_streams(con, id, ROAR_STREAMS_MAX)) == -1 ) {
